<?php
/**
 * SkeletonCart
 * (c) 2020 Juxtaposition Inc. All Rights Reserved.
 * (c) 2020 Curlybracket, Inc. All Rights Reserved.
 * This code cannot be redistributed without permission from the copyright holder.
 * For more information, consult your SkeletonCart license.
 **/

function smarty_modifier_url_sanitize($url){
    # Check valid chars
    if(preg_match('/[^;\/?:@&=+\$,A-Za-z0-9\-_.!~*\'()%]/', $url)) {
        return '';
    }

    # Check valid scheme
    if(preg_match('/^([A-Za-z][A-Za-z0-9+\-.]*):/', $url, $matches)) {
        $scheme = strtolower($matches[1]);
        $allow = 0;
        if($scheme === 'http'
            || $scheme === 'https'
            || $scheme === 'mailto') {
            $allow = 1;
        }
        if(!$allow) {
            return '';
        }
    }

    /* NOTE: commented out the followings, because normally escaped with HTML by default in SkeletonCart view. */
    /*
    # escape
    $url = preg_replace('/&/', '&amp;', $url);
    $url = preg_replace('/\'/', '&#39;', $url);
     */

    return $url;
}




